#######################
# Version definitions #
#######################

ALPINE_VERSION ?= 3.21
PACKER_VERSION ?= 1.10.2
TERRAFORM_VERSION ?= 1.7.5
GO_VERSION ?= 1.23.5

#####################
# CI Registry setup #
#####################

CI_REGISTRY ?= registry.gitlab.com
CI_PROJECT_PATH ?= gitlab-org/ci-cd/shared-runners/images/aws/grit-images
CI_REGISTRY_IMAGE ?= $(CI_REGISTRY)/$(CI_PROJECT_PATH)
CI_IMAGE ?= $(CI_REGISTRY_IMAGE)/ci-$(ARCH):latest

.PHONY: build-ci-image
build-ci-image: IMAGE ?= $(CI_IMAGE)
build-ci-image:
ifdef CI_REGISTRY_USER
	# Logging into $(CI_REGISTRY)
	@docker login --username $(CI_REGISTRY_USER) --password $(CI_REGISTRY_PASSWORD) $(CI_REGISTRY)
	docker pull $(IMAGE) || echo "Remote image $(IMAGE) not available - will not use cache"
endif
	docker --debug build \
			--cache-from $(IMAGE) \
			--build-arg ALPINE_VERSION=$(ALPINE_VERSION) \
			--build-arg PACKER_VERSION=$(PACKER_VERSION) \
			--build-arg TERRAFORM_VERSION=$(TERRAFORM_VERSION) \
			--build-arg GO_VERSION=$(GO_VERSION) \
			--build-arg ARCH=$(ARCH) \
			-t $(IMAGE) \
			-f ./dockerfiles/ci/Dockerfile \
			./dockerfiles/ci/
ifdef CI_REGISTRY_USER
	# Pusing $(IMAGE)
	@docker push $(IMAGE)
	# Logging out from $(CI_REGISTRY)
	@docker logout $(CI_REGISTRY)
endif
